
package de.ivu.elect.presentation.kandidatur;

import static org.apache.commons.lang3.StringUtils.defaultIfBlank;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.kandidatur.boundary.WaehlerBenannteKandidaturEdit;
import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;
import de.ivu.elect.business.personenpruefung.boundary.PersonenKonfliktConversationSelect;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.kandidatur.form.WaehlerBenannteKandidaturViewFormBuilder;

@OnlineHilfeId(value = "196", mehrfachVergebenOk = true)
@Named(WaehlerBenannteDirektkandidaturEditView.COMPONENT_NAME)
@View(viewId = WaehlerBenannteDirektkandidaturEditView.VIEW_ID, useCase = UseCasePermission.WAEHLER_BENANNTE_KANDIDATUR_EDIT)
public class WaehlerBenannteDirektkandidaturEditView extends AbstractDirektkandidaturEditView implements KandidaturEditView {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "waehlerBenannteDirektkandidaturEditView";

  public static final String VIEW_ID = "/kandidatur/waehler-benannte-direktkandidatur-edit.xhtml";

  @Inject
  private transient WaehlerBenannteKandidaturEdit waehlerBenannteKandidaturEdit;

  @Inject
  private transient WaehlerBenannteKandidaturViewFormBuilder waehlerBenannteKandidaturViewFormBuilder;

  @Inject
  private transient PersonenKonfliktConversationSelect personenKonfliktConversationSelect;

  public WaehlerBenannteDirektkandidaturEditView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  @Override
  @PreConditionCheck
  public String checkPreCondition() {
    super.checkPreCondition();

    if (isWaehlerBenannteDirektkandidaturSelected()) {
      return null;
    }

    return cancel();
  }

  @Override
  public String getPageTitle() {
    return getMessage("waehler.benannte.direktkandidatur.edit.page.title", waehlerBenannteKandidaturViewFormBuilder.getEntityEinzahlMessage(getSelectedGebiet()));
  }

  @Override
  public String getPageHeader() {
    return getMessage("waehler.benannte.direktkandidatur.edit.page.header", getDirektkandidaturName(), getGebietName());
  }

  @Override
  protected boolean isGebietBearbeitenRechtPruefen() {
    return true;
  }

  private boolean isWaehlerBenannteDirektkandidaturSelected() {
    return isDirektkandidaturSelected() && waehlerBenannteKandidaturViewFormBuilder.isWaehlerBenannteDirektkandidatur(getEntity());
  }

  private boolean isDirektkandidaturSelected() {
    return isEntitySet();
  }

  public String getDirektkandidaturName() {
    if (isDirektkandidaturSelected()) {
      return defaultIfBlank(getEntity().getFamilienname(), getEntity().getNamePraesentation());
    }

    return "";
  }

  public String getGebietName() {
    if (isDirektkandidaturSelected()) {
      return formatGebietName(getEntity().getGebiet());
    }

    return "";
  }

  @Override
  public void addProperties(FormBuilder formBuilder, Direktkandidatur direktkandidatur) {
    boolean readonly = false;

    if (!direktkandidatur.hasGewaehltVorperiode()) {
      direktkandidatur.setGewaehltVorperiode(waehlerBenannteKandidaturViewFormBuilder.createGewaehltVorperiode(direktkandidatur.getWahl()));
    }

    waehlerBenannteKandidaturViewFormBuilder.addProperties(formBuilder, direktkandidatur, readonly);
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.WAEHLER_BENANNTE_KANDIDATUR_EDIT);
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.WAEHLER_BENANNTE_KANDIDATUR_EDIT)
  public String save() {
    // ELECT-2788: Schließe den Konflikt, da er evtl. gelöst wurde.
    personenKonfliktConversationSelect.clearEntity();

    Direktkandidatur direktkandidatur = getEntity();

    waehlerBenannteKandidaturViewFormBuilder.preSaveEntity(direktkandidatur);

    return super.save();
  }

  @Override
  protected void addMessageSaveSuccess(Direktkandidatur direktkandidatur) {
    addInfoMessage("entity.edit.action.save.success.message", waehlerBenannteKandidaturViewFormBuilder.getEntityEinzahlMessage(getSelectedGebiet()));
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.WAEHLER_BENANNTE_KANDIDATUR_DELETE)
  public String delete() {
    if (isDirektkandidaturSelected()) {
      waehlerBenannteKandidaturEdit.deleteWaehlerBenannteDirektkandidatur(getEntity());

      addMessageDeleteSuccess();

      resetStateAfterAction();
    }

    return getParentViewId();
  }

  @Override
  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", waehlerBenannteKandidaturViewFormBuilder.getEntityEinzahlMessage(getSelectedGebiet()));
  }

  @Override
  protected FormBuilder createFormBuilder() {
    return new FormBuilder(formBuilderConfig);
  }
}
